# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from . import _utilities
from . import outputs
from ._inputs import *

__all__ = ['DeploymentArgs', 'Deployment']

@pulumi.input_type
class DeploymentArgs:
    def __init__(__self__, *,
                 repository: pulumi.Input[str],
                 stage: pulumi.Input[str],
                 name: Optional[pulumi.Input[str]] = None,
                 restrictions: Optional[pulumi.Input['DeploymentRestrictionsArgs']] = None):
        """
        The set of arguments for constructing a Deployment resource.
        :param pulumi.Input[str] repository: The repository ID to which you want to assign this deployment environment to
        :param pulumi.Input[str] stage: The stage (Test, Staging, Production)
        :param pulumi.Input[str] name: The name of the deployment environment
        :param pulumi.Input['DeploymentRestrictionsArgs'] restrictions: Deployment restrictions. See Restrictions below.
        """
        pulumi.set(__self__, "repository", repository)
        pulumi.set(__self__, "stage", stage)
        if name is not None:
            pulumi.set(__self__, "name", name)
        if restrictions is not None:
            pulumi.set(__self__, "restrictions", restrictions)

    @property
    @pulumi.getter
    def repository(self) -> pulumi.Input[str]:
        """
        The repository ID to which you want to assign this deployment environment to
        """
        return pulumi.get(self, "repository")

    @repository.setter
    def repository(self, value: pulumi.Input[str]):
        pulumi.set(self, "repository", value)

    @property
    @pulumi.getter
    def stage(self) -> pulumi.Input[str]:
        """
        The stage (Test, Staging, Production)
        """
        return pulumi.get(self, "stage")

    @stage.setter
    def stage(self, value: pulumi.Input[str]):
        pulumi.set(self, "stage", value)

    @property
    @pulumi.getter
    def name(self) -> Optional[pulumi.Input[str]]:
        """
        The name of the deployment environment
        """
        return pulumi.get(self, "name")

    @name.setter
    def name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "name", value)

    @property
    @pulumi.getter
    def restrictions(self) -> Optional[pulumi.Input['DeploymentRestrictionsArgs']]:
        """
        Deployment restrictions. See Restrictions below.
        """
        return pulumi.get(self, "restrictions")

    @restrictions.setter
    def restrictions(self, value: Optional[pulumi.Input['DeploymentRestrictionsArgs']]):
        pulumi.set(self, "restrictions", value)


@pulumi.input_type
class _DeploymentState:
    def __init__(__self__, *,
                 name: Optional[pulumi.Input[str]] = None,
                 repository: Optional[pulumi.Input[str]] = None,
                 restrictions: Optional[pulumi.Input['DeploymentRestrictionsArgs']] = None,
                 stage: Optional[pulumi.Input[str]] = None,
                 uuid: Optional[pulumi.Input[str]] = None):
        """
        Input properties used for looking up and filtering Deployment resources.
        :param pulumi.Input[str] name: The name of the deployment environment
        :param pulumi.Input[str] repository: The repository ID to which you want to assign this deployment environment to
        :param pulumi.Input['DeploymentRestrictionsArgs'] restrictions: Deployment restrictions. See Restrictions below.
        :param pulumi.Input[str] stage: The stage (Test, Staging, Production)
        :param pulumi.Input[str] uuid: (Computed) The UUID identifying the deployment.
        """
        if name is not None:
            pulumi.set(__self__, "name", name)
        if repository is not None:
            pulumi.set(__self__, "repository", repository)
        if restrictions is not None:
            pulumi.set(__self__, "restrictions", restrictions)
        if stage is not None:
            pulumi.set(__self__, "stage", stage)
        if uuid is not None:
            pulumi.set(__self__, "uuid", uuid)

    @property
    @pulumi.getter
    def name(self) -> Optional[pulumi.Input[str]]:
        """
        The name of the deployment environment
        """
        return pulumi.get(self, "name")

    @name.setter
    def name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "name", value)

    @property
    @pulumi.getter
    def repository(self) -> Optional[pulumi.Input[str]]:
        """
        The repository ID to which you want to assign this deployment environment to
        """
        return pulumi.get(self, "repository")

    @repository.setter
    def repository(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "repository", value)

    @property
    @pulumi.getter
    def restrictions(self) -> Optional[pulumi.Input['DeploymentRestrictionsArgs']]:
        """
        Deployment restrictions. See Restrictions below.
        """
        return pulumi.get(self, "restrictions")

    @restrictions.setter
    def restrictions(self, value: Optional[pulumi.Input['DeploymentRestrictionsArgs']]):
        pulumi.set(self, "restrictions", value)

    @property
    @pulumi.getter
    def stage(self) -> Optional[pulumi.Input[str]]:
        """
        The stage (Test, Staging, Production)
        """
        return pulumi.get(self, "stage")

    @stage.setter
    def stage(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "stage", value)

    @property
    @pulumi.getter
    def uuid(self) -> Optional[pulumi.Input[str]]:
        """
        (Computed) The UUID identifying the deployment.
        """
        return pulumi.get(self, "uuid")

    @uuid.setter
    def uuid(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "uuid", value)


class Deployment(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 repository: Optional[pulumi.Input[str]] = None,
                 restrictions: Optional[pulumi.Input[pulumi.InputType['DeploymentRestrictionsArgs']]] = None,
                 stage: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        """
        This resource allows you to setup pipelines deployment environments.

        OAuth2 Scopes: `none`

        ## Example Usage

        ```python
        import pulumi
        import pulumi_bitbucket as bitbucket

        monorepo = bitbucket.Repository("monorepo",
            owner="gob",
            pipelines_enabled=True)
        test = bitbucket.Deployment("test",
            repository=monorepo.id,
            stage="Test")
        ```

        ## Import

        Deployments can be imported using their `repository/uuid` ID, e.g.

        ```sh
         $ pulumi import bitbucket:index/deployment:Deployment example repository/uuid
        ```

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] name: The name of the deployment environment
        :param pulumi.Input[str] repository: The repository ID to which you want to assign this deployment environment to
        :param pulumi.Input[pulumi.InputType['DeploymentRestrictionsArgs']] restrictions: Deployment restrictions. See Restrictions below.
        :param pulumi.Input[str] stage: The stage (Test, Staging, Production)
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: DeploymentArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        This resource allows you to setup pipelines deployment environments.

        OAuth2 Scopes: `none`

        ## Example Usage

        ```python
        import pulumi
        import pulumi_bitbucket as bitbucket

        monorepo = bitbucket.Repository("monorepo",
            owner="gob",
            pipelines_enabled=True)
        test = bitbucket.Deployment("test",
            repository=monorepo.id,
            stage="Test")
        ```

        ## Import

        Deployments can be imported using their `repository/uuid` ID, e.g.

        ```sh
         $ pulumi import bitbucket:index/deployment:Deployment example repository/uuid
        ```

        :param str resource_name: The name of the resource.
        :param DeploymentArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(DeploymentArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 repository: Optional[pulumi.Input[str]] = None,
                 restrictions: Optional[pulumi.Input[pulumi.InputType['DeploymentRestrictionsArgs']]] = None,
                 stage: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = DeploymentArgs.__new__(DeploymentArgs)

            __props__.__dict__["name"] = name
            if repository is None and not opts.urn:
                raise TypeError("Missing required property 'repository'")
            __props__.__dict__["repository"] = repository
            __props__.__dict__["restrictions"] = restrictions
            if stage is None and not opts.urn:
                raise TypeError("Missing required property 'stage'")
            __props__.__dict__["stage"] = stage
            __props__.__dict__["uuid"] = None
        super(Deployment, __self__).__init__(
            'bitbucket:index/deployment:Deployment',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            name: Optional[pulumi.Input[str]] = None,
            repository: Optional[pulumi.Input[str]] = None,
            restrictions: Optional[pulumi.Input[pulumi.InputType['DeploymentRestrictionsArgs']]] = None,
            stage: Optional[pulumi.Input[str]] = None,
            uuid: Optional[pulumi.Input[str]] = None) -> 'Deployment':
        """
        Get an existing Deployment resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] name: The name of the deployment environment
        :param pulumi.Input[str] repository: The repository ID to which you want to assign this deployment environment to
        :param pulumi.Input[pulumi.InputType['DeploymentRestrictionsArgs']] restrictions: Deployment restrictions. See Restrictions below.
        :param pulumi.Input[str] stage: The stage (Test, Staging, Production)
        :param pulumi.Input[str] uuid: (Computed) The UUID identifying the deployment.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _DeploymentState.__new__(_DeploymentState)

        __props__.__dict__["name"] = name
        __props__.__dict__["repository"] = repository
        __props__.__dict__["restrictions"] = restrictions
        __props__.__dict__["stage"] = stage
        __props__.__dict__["uuid"] = uuid
        return Deployment(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter
    def name(self) -> pulumi.Output[str]:
        """
        The name of the deployment environment
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def repository(self) -> pulumi.Output[str]:
        """
        The repository ID to which you want to assign this deployment environment to
        """
        return pulumi.get(self, "repository")

    @property
    @pulumi.getter
    def restrictions(self) -> pulumi.Output['outputs.DeploymentRestrictions']:
        """
        Deployment restrictions. See Restrictions below.
        """
        return pulumi.get(self, "restrictions")

    @property
    @pulumi.getter
    def stage(self) -> pulumi.Output[str]:
        """
        The stage (Test, Staging, Production)
        """
        return pulumi.get(self, "stage")

    @property
    @pulumi.getter
    def uuid(self) -> pulumi.Output[str]:
        """
        (Computed) The UUID identifying the deployment.
        """
        return pulumi.get(self, "uuid")

