# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from . import _utilities

__all__ = [
    'GetUserResult',
    'AwaitableGetUserResult',
    'get_user',
    'get_user_output',
]

@pulumi.output_type
class GetUserResult:
    """
    A collection of values returned by getUser.
    """
    def __init__(__self__, display_name=None, id=None, username=None, uuid=None):
        if display_name and not isinstance(display_name, str):
            raise TypeError("Expected argument 'display_name' to be a str")
        pulumi.set(__self__, "display_name", display_name)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if username and not isinstance(username, str):
            raise TypeError("Expected argument 'username' to be a str")
        pulumi.set(__self__, "username", username)
        if uuid and not isinstance(uuid, str):
            raise TypeError("Expected argument 'uuid' to be a str")
        pulumi.set(__self__, "uuid", uuid)

    @property
    @pulumi.getter(name="displayName")
    def display_name(self) -> Optional[str]:
        """
        the display name that the user wants to use for GDPR
        """
        return pulumi.get(self, "display_name")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def username(self) -> str:
        return pulumi.get(self, "username")

    @property
    @pulumi.getter
    def uuid(self) -> Optional[str]:
        """
        the uuid that bitbucket users to connect a user to various objects
        """
        return pulumi.get(self, "uuid")


class AwaitableGetUserResult(GetUserResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetUserResult(
            display_name=self.display_name,
            id=self.id,
            username=self.username,
            uuid=self.uuid)


def get_user(display_name: Optional[str] = None,
             uuid: Optional[str] = None,
             opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetUserResult:
    """
    Provides a way to fetch data on a user.

    ## Example Usage

    ```python
    import pulumi
    import pulumi_bitbucket as bitbucket

    reviewer = bitbucket.get_user(uuid="{account UUID}")
    ```


    :param str display_name: the display name that the user wants to use for GDPR
    :param str uuid: The UUID that bitbucket users to connect a user to various objects
    """
    __args__ = dict()
    __args__['displayName'] = display_name
    __args__['uuid'] = uuid
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('bitbucket:index/getUser:getUser', __args__, opts=opts, typ=GetUserResult).value

    return AwaitableGetUserResult(
        display_name=pulumi.get(__ret__, 'display_name'),
        id=pulumi.get(__ret__, 'id'),
        username=pulumi.get(__ret__, 'username'),
        uuid=pulumi.get(__ret__, 'uuid'))


@_utilities.lift_output_func(get_user)
def get_user_output(display_name: Optional[pulumi.Input[Optional[str]]] = None,
                    uuid: Optional[pulumi.Input[Optional[str]]] = None,
                    opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetUserResult]:
    """
    Provides a way to fetch data on a user.

    ## Example Usage

    ```python
    import pulumi
    import pulumi_bitbucket as bitbucket

    reviewer = bitbucket.get_user(uuid="{account UUID}")
    ```


    :param str display_name: the display name that the user wants to use for GDPR
    :param str uuid: The UUID that bitbucket users to connect a user to various objects
    """
    ...
