# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from . import _utilities

__all__ = ['GroupMembershipArgs', 'GroupMembership']

@pulumi.input_type
class GroupMembershipArgs:
    def __init__(__self__, *,
                 group_slug: pulumi.Input[str],
                 uuid: pulumi.Input[str],
                 workspace: pulumi.Input[str]):
        """
        The set of arguments for constructing a GroupMembership resource.
        :param pulumi.Input[str] group_slug: The slug of the group.
        :param pulumi.Input[str] uuid: The member UUID to add to the group.
        :param pulumi.Input[str] workspace: The workspace of this repository.
        """
        pulumi.set(__self__, "group_slug", group_slug)
        pulumi.set(__self__, "uuid", uuid)
        pulumi.set(__self__, "workspace", workspace)

    @property
    @pulumi.getter(name="groupSlug")
    def group_slug(self) -> pulumi.Input[str]:
        """
        The slug of the group.
        """
        return pulumi.get(self, "group_slug")

    @group_slug.setter
    def group_slug(self, value: pulumi.Input[str]):
        pulumi.set(self, "group_slug", value)

    @property
    @pulumi.getter
    def uuid(self) -> pulumi.Input[str]:
        """
        The member UUID to add to the group.
        """
        return pulumi.get(self, "uuid")

    @uuid.setter
    def uuid(self, value: pulumi.Input[str]):
        pulumi.set(self, "uuid", value)

    @property
    @pulumi.getter
    def workspace(self) -> pulumi.Input[str]:
        """
        The workspace of this repository.
        """
        return pulumi.get(self, "workspace")

    @workspace.setter
    def workspace(self, value: pulumi.Input[str]):
        pulumi.set(self, "workspace", value)


@pulumi.input_type
class _GroupMembershipState:
    def __init__(__self__, *,
                 group_slug: Optional[pulumi.Input[str]] = None,
                 slug: Optional[pulumi.Input[str]] = None,
                 uuid: Optional[pulumi.Input[str]] = None,
                 workspace: Optional[pulumi.Input[str]] = None):
        """
        Input properties used for looking up and filtering GroupMembership resources.
        :param pulumi.Input[str] group_slug: The slug of the group.
        :param pulumi.Input[str] uuid: The member UUID to add to the group.
        :param pulumi.Input[str] workspace: The workspace of this repository.
        """
        if group_slug is not None:
            pulumi.set(__self__, "group_slug", group_slug)
        if slug is not None:
            pulumi.set(__self__, "slug", slug)
        if uuid is not None:
            pulumi.set(__self__, "uuid", uuid)
        if workspace is not None:
            pulumi.set(__self__, "workspace", workspace)

    @property
    @pulumi.getter(name="groupSlug")
    def group_slug(self) -> Optional[pulumi.Input[str]]:
        """
        The slug of the group.
        """
        return pulumi.get(self, "group_slug")

    @group_slug.setter
    def group_slug(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "group_slug", value)

    @property
    @pulumi.getter
    def slug(self) -> Optional[pulumi.Input[str]]:
        return pulumi.get(self, "slug")

    @slug.setter
    def slug(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "slug", value)

    @property
    @pulumi.getter
    def uuid(self) -> Optional[pulumi.Input[str]]:
        """
        The member UUID to add to the group.
        """
        return pulumi.get(self, "uuid")

    @uuid.setter
    def uuid(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "uuid", value)

    @property
    @pulumi.getter
    def workspace(self) -> Optional[pulumi.Input[str]]:
        """
        The workspace of this repository.
        """
        return pulumi.get(self, "workspace")

    @workspace.setter
    def workspace(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "workspace", value)


class GroupMembership(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 group_slug: Optional[pulumi.Input[str]] = None,
                 uuid: Optional[pulumi.Input[str]] = None,
                 workspace: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        """
        Provides a Bitbucket group membership resource.

        This allows you to manage your group membership.

        ## Example Usage

        ```python
        import pulumi
        import pulumi_bitbucket as bitbucket

        test_workspace = bitbucket.get_workspace(workspace="example")
        test_group = bitbucket.Group("testGroup", workspace=test_workspace.id)
        test_current_user = bitbucket.get_current_user()
        test_group_membership = bitbucket.GroupMembership("testGroupMembership",
            workspace=test_group.workspace,
            group_slug=test_group.slug,
            uuid=test_current_user.id)
        ```

        ## Import

        Group Members can be imported using their `workspace/group-slug/member-uuid` ID, e.g.

        ```sh
         $ pulumi import bitbucket:index/groupMembership:GroupMembership group my-workspace/group-slug/member-uuid
        ```

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] group_slug: The slug of the group.
        :param pulumi.Input[str] uuid: The member UUID to add to the group.
        :param pulumi.Input[str] workspace: The workspace of this repository.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: GroupMembershipArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Provides a Bitbucket group membership resource.

        This allows you to manage your group membership.

        ## Example Usage

        ```python
        import pulumi
        import pulumi_bitbucket as bitbucket

        test_workspace = bitbucket.get_workspace(workspace="example")
        test_group = bitbucket.Group("testGroup", workspace=test_workspace.id)
        test_current_user = bitbucket.get_current_user()
        test_group_membership = bitbucket.GroupMembership("testGroupMembership",
            workspace=test_group.workspace,
            group_slug=test_group.slug,
            uuid=test_current_user.id)
        ```

        ## Import

        Group Members can be imported using their `workspace/group-slug/member-uuid` ID, e.g.

        ```sh
         $ pulumi import bitbucket:index/groupMembership:GroupMembership group my-workspace/group-slug/member-uuid
        ```

        :param str resource_name: The name of the resource.
        :param GroupMembershipArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(GroupMembershipArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 group_slug: Optional[pulumi.Input[str]] = None,
                 uuid: Optional[pulumi.Input[str]] = None,
                 workspace: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = GroupMembershipArgs.__new__(GroupMembershipArgs)

            if group_slug is None and not opts.urn:
                raise TypeError("Missing required property 'group_slug'")
            __props__.__dict__["group_slug"] = group_slug
            if uuid is None and not opts.urn:
                raise TypeError("Missing required property 'uuid'")
            __props__.__dict__["uuid"] = uuid
            if workspace is None and not opts.urn:
                raise TypeError("Missing required property 'workspace'")
            __props__.__dict__["workspace"] = workspace
            __props__.__dict__["slug"] = None
        super(GroupMembership, __self__).__init__(
            'bitbucket:index/groupMembership:GroupMembership',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            group_slug: Optional[pulumi.Input[str]] = None,
            slug: Optional[pulumi.Input[str]] = None,
            uuid: Optional[pulumi.Input[str]] = None,
            workspace: Optional[pulumi.Input[str]] = None) -> 'GroupMembership':
        """
        Get an existing GroupMembership resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] group_slug: The slug of the group.
        :param pulumi.Input[str] uuid: The member UUID to add to the group.
        :param pulumi.Input[str] workspace: The workspace of this repository.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _GroupMembershipState.__new__(_GroupMembershipState)

        __props__.__dict__["group_slug"] = group_slug
        __props__.__dict__["slug"] = slug
        __props__.__dict__["uuid"] = uuid
        __props__.__dict__["workspace"] = workspace
        return GroupMembership(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="groupSlug")
    def group_slug(self) -> pulumi.Output[str]:
        """
        The slug of the group.
        """
        return pulumi.get(self, "group_slug")

    @property
    @pulumi.getter
    def slug(self) -> pulumi.Output[str]:
        return pulumi.get(self, "slug")

    @property
    @pulumi.getter
    def uuid(self) -> pulumi.Output[str]:
        """
        The member UUID to add to the group.
        """
        return pulumi.get(self, "uuid")

    @property
    @pulumi.getter
    def workspace(self) -> pulumi.Output[str]:
        """
        The workspace of this repository.
        """
        return pulumi.get(self, "workspace")

