# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from . import _utilities
from . import outputs
from ._inputs import *

__all__ = ['PipelineScheduleArgs', 'PipelineSchedule']

@pulumi.input_type
class PipelineScheduleArgs:
    def __init__(__self__, *,
                 cron_pattern: pulumi.Input[str],
                 enabled: pulumi.Input[bool],
                 repository: pulumi.Input[str],
                 target: pulumi.Input['PipelineScheduleTargetArgs'],
                 workspace: pulumi.Input[str]):
        """
        The set of arguments for constructing a PipelineSchedule resource.
        :param pulumi.Input[str] cron_pattern: The cron expression that the schedule applies.
        :param pulumi.Input[bool] enabled: Whether the schedule is enabled.
        :param pulumi.Input[str] repository: The Repository to create schedule in.
        :param pulumi.Input['PipelineScheduleTargetArgs'] target: Schedule Target definition. See Target below.
        :param pulumi.Input[str] workspace: The Workspace where the repository resides.
        """
        pulumi.set(__self__, "cron_pattern", cron_pattern)
        pulumi.set(__self__, "enabled", enabled)
        pulumi.set(__self__, "repository", repository)
        pulumi.set(__self__, "target", target)
        pulumi.set(__self__, "workspace", workspace)

    @property
    @pulumi.getter(name="cronPattern")
    def cron_pattern(self) -> pulumi.Input[str]:
        """
        The cron expression that the schedule applies.
        """
        return pulumi.get(self, "cron_pattern")

    @cron_pattern.setter
    def cron_pattern(self, value: pulumi.Input[str]):
        pulumi.set(self, "cron_pattern", value)

    @property
    @pulumi.getter
    def enabled(self) -> pulumi.Input[bool]:
        """
        Whether the schedule is enabled.
        """
        return pulumi.get(self, "enabled")

    @enabled.setter
    def enabled(self, value: pulumi.Input[bool]):
        pulumi.set(self, "enabled", value)

    @property
    @pulumi.getter
    def repository(self) -> pulumi.Input[str]:
        """
        The Repository to create schedule in.
        """
        return pulumi.get(self, "repository")

    @repository.setter
    def repository(self, value: pulumi.Input[str]):
        pulumi.set(self, "repository", value)

    @property
    @pulumi.getter
    def target(self) -> pulumi.Input['PipelineScheduleTargetArgs']:
        """
        Schedule Target definition. See Target below.
        """
        return pulumi.get(self, "target")

    @target.setter
    def target(self, value: pulumi.Input['PipelineScheduleTargetArgs']):
        pulumi.set(self, "target", value)

    @property
    @pulumi.getter
    def workspace(self) -> pulumi.Input[str]:
        """
        The Workspace where the repository resides.
        """
        return pulumi.get(self, "workspace")

    @workspace.setter
    def workspace(self, value: pulumi.Input[str]):
        pulumi.set(self, "workspace", value)


@pulumi.input_type
class _PipelineScheduleState:
    def __init__(__self__, *,
                 cron_pattern: Optional[pulumi.Input[str]] = None,
                 enabled: Optional[pulumi.Input[bool]] = None,
                 repository: Optional[pulumi.Input[str]] = None,
                 target: Optional[pulumi.Input['PipelineScheduleTargetArgs']] = None,
                 uuid: Optional[pulumi.Input[str]] = None,
                 workspace: Optional[pulumi.Input[str]] = None):
        """
        Input properties used for looking up and filtering PipelineSchedule resources.
        :param pulumi.Input[str] cron_pattern: The cron expression that the schedule applies.
        :param pulumi.Input[bool] enabled: Whether the schedule is enabled.
        :param pulumi.Input[str] repository: The Repository to create schedule in.
        :param pulumi.Input['PipelineScheduleTargetArgs'] target: Schedule Target definition. See Target below.
        :param pulumi.Input[str] uuid: The UUID identifying the schedule.
        :param pulumi.Input[str] workspace: The Workspace where the repository resides.
        """
        if cron_pattern is not None:
            pulumi.set(__self__, "cron_pattern", cron_pattern)
        if enabled is not None:
            pulumi.set(__self__, "enabled", enabled)
        if repository is not None:
            pulumi.set(__self__, "repository", repository)
        if target is not None:
            pulumi.set(__self__, "target", target)
        if uuid is not None:
            pulumi.set(__self__, "uuid", uuid)
        if workspace is not None:
            pulumi.set(__self__, "workspace", workspace)

    @property
    @pulumi.getter(name="cronPattern")
    def cron_pattern(self) -> Optional[pulumi.Input[str]]:
        """
        The cron expression that the schedule applies.
        """
        return pulumi.get(self, "cron_pattern")

    @cron_pattern.setter
    def cron_pattern(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "cron_pattern", value)

    @property
    @pulumi.getter
    def enabled(self) -> Optional[pulumi.Input[bool]]:
        """
        Whether the schedule is enabled.
        """
        return pulumi.get(self, "enabled")

    @enabled.setter
    def enabled(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "enabled", value)

    @property
    @pulumi.getter
    def repository(self) -> Optional[pulumi.Input[str]]:
        """
        The Repository to create schedule in.
        """
        return pulumi.get(self, "repository")

    @repository.setter
    def repository(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "repository", value)

    @property
    @pulumi.getter
    def target(self) -> Optional[pulumi.Input['PipelineScheduleTargetArgs']]:
        """
        Schedule Target definition. See Target below.
        """
        return pulumi.get(self, "target")

    @target.setter
    def target(self, value: Optional[pulumi.Input['PipelineScheduleTargetArgs']]):
        pulumi.set(self, "target", value)

    @property
    @pulumi.getter
    def uuid(self) -> Optional[pulumi.Input[str]]:
        """
        The UUID identifying the schedule.
        """
        return pulumi.get(self, "uuid")

    @uuid.setter
    def uuid(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "uuid", value)

    @property
    @pulumi.getter
    def workspace(self) -> Optional[pulumi.Input[str]]:
        """
        The Workspace where the repository resides.
        """
        return pulumi.get(self, "workspace")

    @workspace.setter
    def workspace(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "workspace", value)


class PipelineSchedule(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 cron_pattern: Optional[pulumi.Input[str]] = None,
                 enabled: Optional[pulumi.Input[bool]] = None,
                 repository: Optional[pulumi.Input[str]] = None,
                 target: Optional[pulumi.Input[pulumi.InputType['PipelineScheduleTargetArgs']]] = None,
                 workspace: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        """
        Provides a Bitbucket Pipeline Schedule resource.

        This allows you to manage your Pipeline Schedules for a repository.

        OAuth2 Scopes: `none`

        ## Example Usage

        ```python
        import pulumi
        import pulumi_bitbucket as bitbucket

        test = bitbucket.PipelineSchedule("test",
            workspace="example",
            repository=bitbucket_repository["test"]["name"],
            cron_pattern="0 30 * * * ? *",
            enabled=True,
            target=bitbucket.PipelineScheduleTargetArgs(
                ref_name="master",
                ref_type="branch",
                selector=bitbucket.PipelineScheduleTargetSelectorArgs(
                    pattern="staging",
                ),
            ))
        ```

        ## Import

        Pipeline Schedules can be imported using their `workspace/repo-slug/uuid` ID, e.g.

        ```sh
         $ pulumi import bitbucket:index/pipelineSchedule:PipelineSchedule schedule workspace/repo-slug/uuid
        ```

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] cron_pattern: The cron expression that the schedule applies.
        :param pulumi.Input[bool] enabled: Whether the schedule is enabled.
        :param pulumi.Input[str] repository: The Repository to create schedule in.
        :param pulumi.Input[pulumi.InputType['PipelineScheduleTargetArgs']] target: Schedule Target definition. See Target below.
        :param pulumi.Input[str] workspace: The Workspace where the repository resides.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: PipelineScheduleArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Provides a Bitbucket Pipeline Schedule resource.

        This allows you to manage your Pipeline Schedules for a repository.

        OAuth2 Scopes: `none`

        ## Example Usage

        ```python
        import pulumi
        import pulumi_bitbucket as bitbucket

        test = bitbucket.PipelineSchedule("test",
            workspace="example",
            repository=bitbucket_repository["test"]["name"],
            cron_pattern="0 30 * * * ? *",
            enabled=True,
            target=bitbucket.PipelineScheduleTargetArgs(
                ref_name="master",
                ref_type="branch",
                selector=bitbucket.PipelineScheduleTargetSelectorArgs(
                    pattern="staging",
                ),
            ))
        ```

        ## Import

        Pipeline Schedules can be imported using their `workspace/repo-slug/uuid` ID, e.g.

        ```sh
         $ pulumi import bitbucket:index/pipelineSchedule:PipelineSchedule schedule workspace/repo-slug/uuid
        ```

        :param str resource_name: The name of the resource.
        :param PipelineScheduleArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(PipelineScheduleArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 cron_pattern: Optional[pulumi.Input[str]] = None,
                 enabled: Optional[pulumi.Input[bool]] = None,
                 repository: Optional[pulumi.Input[str]] = None,
                 target: Optional[pulumi.Input[pulumi.InputType['PipelineScheduleTargetArgs']]] = None,
                 workspace: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = PipelineScheduleArgs.__new__(PipelineScheduleArgs)

            if cron_pattern is None and not opts.urn:
                raise TypeError("Missing required property 'cron_pattern'")
            __props__.__dict__["cron_pattern"] = cron_pattern
            if enabled is None and not opts.urn:
                raise TypeError("Missing required property 'enabled'")
            __props__.__dict__["enabled"] = enabled
            if repository is None and not opts.urn:
                raise TypeError("Missing required property 'repository'")
            __props__.__dict__["repository"] = repository
            if target is None and not opts.urn:
                raise TypeError("Missing required property 'target'")
            __props__.__dict__["target"] = target
            if workspace is None and not opts.urn:
                raise TypeError("Missing required property 'workspace'")
            __props__.__dict__["workspace"] = workspace
            __props__.__dict__["uuid"] = None
        super(PipelineSchedule, __self__).__init__(
            'bitbucket:index/pipelineSchedule:PipelineSchedule',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            cron_pattern: Optional[pulumi.Input[str]] = None,
            enabled: Optional[pulumi.Input[bool]] = None,
            repository: Optional[pulumi.Input[str]] = None,
            target: Optional[pulumi.Input[pulumi.InputType['PipelineScheduleTargetArgs']]] = None,
            uuid: Optional[pulumi.Input[str]] = None,
            workspace: Optional[pulumi.Input[str]] = None) -> 'PipelineSchedule':
        """
        Get an existing PipelineSchedule resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] cron_pattern: The cron expression that the schedule applies.
        :param pulumi.Input[bool] enabled: Whether the schedule is enabled.
        :param pulumi.Input[str] repository: The Repository to create schedule in.
        :param pulumi.Input[pulumi.InputType['PipelineScheduleTargetArgs']] target: Schedule Target definition. See Target below.
        :param pulumi.Input[str] uuid: The UUID identifying the schedule.
        :param pulumi.Input[str] workspace: The Workspace where the repository resides.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _PipelineScheduleState.__new__(_PipelineScheduleState)

        __props__.__dict__["cron_pattern"] = cron_pattern
        __props__.__dict__["enabled"] = enabled
        __props__.__dict__["repository"] = repository
        __props__.__dict__["target"] = target
        __props__.__dict__["uuid"] = uuid
        __props__.__dict__["workspace"] = workspace
        return PipelineSchedule(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="cronPattern")
    def cron_pattern(self) -> pulumi.Output[str]:
        """
        The cron expression that the schedule applies.
        """
        return pulumi.get(self, "cron_pattern")

    @property
    @pulumi.getter
    def enabled(self) -> pulumi.Output[bool]:
        """
        Whether the schedule is enabled.
        """
        return pulumi.get(self, "enabled")

    @property
    @pulumi.getter
    def repository(self) -> pulumi.Output[str]:
        """
        The Repository to create schedule in.
        """
        return pulumi.get(self, "repository")

    @property
    @pulumi.getter
    def target(self) -> pulumi.Output['outputs.PipelineScheduleTarget']:
        """
        Schedule Target definition. See Target below.
        """
        return pulumi.get(self, "target")

    @property
    @pulumi.getter
    def uuid(self) -> pulumi.Output[str]:
        """
        The UUID identifying the schedule.
        """
        return pulumi.get(self, "uuid")

    @property
    @pulumi.getter
    def workspace(self) -> pulumi.Output[str]:
        """
        The Workspace where the repository resides.
        """
        return pulumi.get(self, "workspace")

