# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from . import _utilities

__all__ = ['PipelineSshKeyArgs', 'PipelineSshKey']

@pulumi.input_type
class PipelineSshKeyArgs:
    def __init__(__self__, *,
                 repository: pulumi.Input[str],
                 workspace: pulumi.Input[str],
                 private_key: Optional[pulumi.Input[str]] = None,
                 public_key: Optional[pulumi.Input[str]] = None):
        """
        The set of arguments for constructing a PipelineSshKey resource.
        :param pulumi.Input[str] repository: The Repository to create ssh key in.
        :param pulumi.Input[str] workspace: The Workspace where the repository resides.
        :param pulumi.Input[str] private_key: The SSH private key value in OpenSSH format.
        :param pulumi.Input[str] public_key: The SSH public key value in OpenSSH format.
        """
        pulumi.set(__self__, "repository", repository)
        pulumi.set(__self__, "workspace", workspace)
        if private_key is not None:
            pulumi.set(__self__, "private_key", private_key)
        if public_key is not None:
            pulumi.set(__self__, "public_key", public_key)

    @property
    @pulumi.getter
    def repository(self) -> pulumi.Input[str]:
        """
        The Repository to create ssh key in.
        """
        return pulumi.get(self, "repository")

    @repository.setter
    def repository(self, value: pulumi.Input[str]):
        pulumi.set(self, "repository", value)

    @property
    @pulumi.getter
    def workspace(self) -> pulumi.Input[str]:
        """
        The Workspace where the repository resides.
        """
        return pulumi.get(self, "workspace")

    @workspace.setter
    def workspace(self, value: pulumi.Input[str]):
        pulumi.set(self, "workspace", value)

    @property
    @pulumi.getter(name="privateKey")
    def private_key(self) -> Optional[pulumi.Input[str]]:
        """
        The SSH private key value in OpenSSH format.
        """
        return pulumi.get(self, "private_key")

    @private_key.setter
    def private_key(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "private_key", value)

    @property
    @pulumi.getter(name="publicKey")
    def public_key(self) -> Optional[pulumi.Input[str]]:
        """
        The SSH public key value in OpenSSH format.
        """
        return pulumi.get(self, "public_key")

    @public_key.setter
    def public_key(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "public_key", value)


@pulumi.input_type
class _PipelineSshKeyState:
    def __init__(__self__, *,
                 private_key: Optional[pulumi.Input[str]] = None,
                 public_key: Optional[pulumi.Input[str]] = None,
                 repository: Optional[pulumi.Input[str]] = None,
                 workspace: Optional[pulumi.Input[str]] = None):
        """
        Input properties used for looking up and filtering PipelineSshKey resources.
        :param pulumi.Input[str] private_key: The SSH private key value in OpenSSH format.
        :param pulumi.Input[str] public_key: The SSH public key value in OpenSSH format.
        :param pulumi.Input[str] repository: The Repository to create ssh key in.
        :param pulumi.Input[str] workspace: The Workspace where the repository resides.
        """
        if private_key is not None:
            pulumi.set(__self__, "private_key", private_key)
        if public_key is not None:
            pulumi.set(__self__, "public_key", public_key)
        if repository is not None:
            pulumi.set(__self__, "repository", repository)
        if workspace is not None:
            pulumi.set(__self__, "workspace", workspace)

    @property
    @pulumi.getter(name="privateKey")
    def private_key(self) -> Optional[pulumi.Input[str]]:
        """
        The SSH private key value in OpenSSH format.
        """
        return pulumi.get(self, "private_key")

    @private_key.setter
    def private_key(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "private_key", value)

    @property
    @pulumi.getter(name="publicKey")
    def public_key(self) -> Optional[pulumi.Input[str]]:
        """
        The SSH public key value in OpenSSH format.
        """
        return pulumi.get(self, "public_key")

    @public_key.setter
    def public_key(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "public_key", value)

    @property
    @pulumi.getter
    def repository(self) -> Optional[pulumi.Input[str]]:
        """
        The Repository to create ssh key in.
        """
        return pulumi.get(self, "repository")

    @repository.setter
    def repository(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "repository", value)

    @property
    @pulumi.getter
    def workspace(self) -> Optional[pulumi.Input[str]]:
        """
        The Workspace where the repository resides.
        """
        return pulumi.get(self, "workspace")

    @workspace.setter
    def workspace(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "workspace", value)


class PipelineSshKey(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 private_key: Optional[pulumi.Input[str]] = None,
                 public_key: Optional[pulumi.Input[str]] = None,
                 repository: Optional[pulumi.Input[str]] = None,
                 workspace: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        """
        Provides a Bitbucket Pipeline Ssh Key resource.

        This allows you to manage your Pipeline Ssh Keys for a repository.

        OAuth2 Scopes: `none`

        ## Example Usage

        ```python
        import pulumi
        import pulumi_bitbucket as bitbucket

        test = bitbucket.PipelineSshKey("test",
            private_key="test-key",
            public_key="ssh-ed25519 AAAAC3NzaC1lZDI1NTE5AAAAIKqP3Cr632C2dNhhgKVcon4ldUSAeKiku2yP9O9/bDtY",
            repository="example",
            workspace="example")
        ```

        ## Import

        Pipeline Ssh Keys can be imported using their `workspace/repo-slug` ID, e.g.

        ```sh
         $ pulumi import bitbucket:index/pipelineSshKey:PipelineSshKey key workspace/repo-slug
        ```

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] private_key: The SSH private key value in OpenSSH format.
        :param pulumi.Input[str] public_key: The SSH public key value in OpenSSH format.
        :param pulumi.Input[str] repository: The Repository to create ssh key in.
        :param pulumi.Input[str] workspace: The Workspace where the repository resides.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: PipelineSshKeyArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Provides a Bitbucket Pipeline Ssh Key resource.

        This allows you to manage your Pipeline Ssh Keys for a repository.

        OAuth2 Scopes: `none`

        ## Example Usage

        ```python
        import pulumi
        import pulumi_bitbucket as bitbucket

        test = bitbucket.PipelineSshKey("test",
            private_key="test-key",
            public_key="ssh-ed25519 AAAAC3NzaC1lZDI1NTE5AAAAIKqP3Cr632C2dNhhgKVcon4ldUSAeKiku2yP9O9/bDtY",
            repository="example",
            workspace="example")
        ```

        ## Import

        Pipeline Ssh Keys can be imported using their `workspace/repo-slug` ID, e.g.

        ```sh
         $ pulumi import bitbucket:index/pipelineSshKey:PipelineSshKey key workspace/repo-slug
        ```

        :param str resource_name: The name of the resource.
        :param PipelineSshKeyArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(PipelineSshKeyArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 private_key: Optional[pulumi.Input[str]] = None,
                 public_key: Optional[pulumi.Input[str]] = None,
                 repository: Optional[pulumi.Input[str]] = None,
                 workspace: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = PipelineSshKeyArgs.__new__(PipelineSshKeyArgs)

            __props__.__dict__["private_key"] = private_key
            __props__.__dict__["public_key"] = public_key
            if repository is None and not opts.urn:
                raise TypeError("Missing required property 'repository'")
            __props__.__dict__["repository"] = repository
            if workspace is None and not opts.urn:
                raise TypeError("Missing required property 'workspace'")
            __props__.__dict__["workspace"] = workspace
        super(PipelineSshKey, __self__).__init__(
            'bitbucket:index/pipelineSshKey:PipelineSshKey',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            private_key: Optional[pulumi.Input[str]] = None,
            public_key: Optional[pulumi.Input[str]] = None,
            repository: Optional[pulumi.Input[str]] = None,
            workspace: Optional[pulumi.Input[str]] = None) -> 'PipelineSshKey':
        """
        Get an existing PipelineSshKey resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] private_key: The SSH private key value in OpenSSH format.
        :param pulumi.Input[str] public_key: The SSH public key value in OpenSSH format.
        :param pulumi.Input[str] repository: The Repository to create ssh key in.
        :param pulumi.Input[str] workspace: The Workspace where the repository resides.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _PipelineSshKeyState.__new__(_PipelineSshKeyState)

        __props__.__dict__["private_key"] = private_key
        __props__.__dict__["public_key"] = public_key
        __props__.__dict__["repository"] = repository
        __props__.__dict__["workspace"] = workspace
        return PipelineSshKey(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="privateKey")
    def private_key(self) -> pulumi.Output[Optional[str]]:
        """
        The SSH private key value in OpenSSH format.
        """
        return pulumi.get(self, "private_key")

    @property
    @pulumi.getter(name="publicKey")
    def public_key(self) -> pulumi.Output[Optional[str]]:
        """
        The SSH public key value in OpenSSH format.
        """
        return pulumi.get(self, "public_key")

    @property
    @pulumi.getter
    def repository(self) -> pulumi.Output[str]:
        """
        The Repository to create ssh key in.
        """
        return pulumi.get(self, "repository")

    @property
    @pulumi.getter
    def workspace(self) -> pulumi.Output[str]:
        """
        The Workspace where the repository resides.
        """
        return pulumi.get(self, "workspace")

