# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from . import _utilities

__all__ = ['RepositoryGroupPermissionArgs', 'RepositoryGroupPermission']

@pulumi.input_type
class RepositoryGroupPermissionArgs:
    def __init__(__self__, *,
                 group_slug: pulumi.Input[str],
                 permission: pulumi.Input[str],
                 repo_slug: pulumi.Input[str],
                 workspace: pulumi.Input[str]):
        """
        The set of arguments for constructing a RepositoryGroupPermission resource.
        :param pulumi.Input[str] group_slug: Slug of the requested group.
        :param pulumi.Input[str] permission: Permissions can be one of `read`, `write`, and `admin`.
        :param pulumi.Input[str] repo_slug: The repository slug.
        :param pulumi.Input[str] workspace: The workspace id.
        """
        pulumi.set(__self__, "group_slug", group_slug)
        pulumi.set(__self__, "permission", permission)
        pulumi.set(__self__, "repo_slug", repo_slug)
        pulumi.set(__self__, "workspace", workspace)

    @property
    @pulumi.getter(name="groupSlug")
    def group_slug(self) -> pulumi.Input[str]:
        """
        Slug of the requested group.
        """
        return pulumi.get(self, "group_slug")

    @group_slug.setter
    def group_slug(self, value: pulumi.Input[str]):
        pulumi.set(self, "group_slug", value)

    @property
    @pulumi.getter
    def permission(self) -> pulumi.Input[str]:
        """
        Permissions can be one of `read`, `write`, and `admin`.
        """
        return pulumi.get(self, "permission")

    @permission.setter
    def permission(self, value: pulumi.Input[str]):
        pulumi.set(self, "permission", value)

    @property
    @pulumi.getter(name="repoSlug")
    def repo_slug(self) -> pulumi.Input[str]:
        """
        The repository slug.
        """
        return pulumi.get(self, "repo_slug")

    @repo_slug.setter
    def repo_slug(self, value: pulumi.Input[str]):
        pulumi.set(self, "repo_slug", value)

    @property
    @pulumi.getter
    def workspace(self) -> pulumi.Input[str]:
        """
        The workspace id.
        """
        return pulumi.get(self, "workspace")

    @workspace.setter
    def workspace(self, value: pulumi.Input[str]):
        pulumi.set(self, "workspace", value)


@pulumi.input_type
class _RepositoryGroupPermissionState:
    def __init__(__self__, *,
                 group_slug: Optional[pulumi.Input[str]] = None,
                 permission: Optional[pulumi.Input[str]] = None,
                 repo_slug: Optional[pulumi.Input[str]] = None,
                 workspace: Optional[pulumi.Input[str]] = None):
        """
        Input properties used for looking up and filtering RepositoryGroupPermission resources.
        :param pulumi.Input[str] group_slug: Slug of the requested group.
        :param pulumi.Input[str] permission: Permissions can be one of `read`, `write`, and `admin`.
        :param pulumi.Input[str] repo_slug: The repository slug.
        :param pulumi.Input[str] workspace: The workspace id.
        """
        if group_slug is not None:
            pulumi.set(__self__, "group_slug", group_slug)
        if permission is not None:
            pulumi.set(__self__, "permission", permission)
        if repo_slug is not None:
            pulumi.set(__self__, "repo_slug", repo_slug)
        if workspace is not None:
            pulumi.set(__self__, "workspace", workspace)

    @property
    @pulumi.getter(name="groupSlug")
    def group_slug(self) -> Optional[pulumi.Input[str]]:
        """
        Slug of the requested group.
        """
        return pulumi.get(self, "group_slug")

    @group_slug.setter
    def group_slug(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "group_slug", value)

    @property
    @pulumi.getter
    def permission(self) -> Optional[pulumi.Input[str]]:
        """
        Permissions can be one of `read`, `write`, and `admin`.
        """
        return pulumi.get(self, "permission")

    @permission.setter
    def permission(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "permission", value)

    @property
    @pulumi.getter(name="repoSlug")
    def repo_slug(self) -> Optional[pulumi.Input[str]]:
        """
        The repository slug.
        """
        return pulumi.get(self, "repo_slug")

    @repo_slug.setter
    def repo_slug(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "repo_slug", value)

    @property
    @pulumi.getter
    def workspace(self) -> Optional[pulumi.Input[str]]:
        """
        The workspace id.
        """
        return pulumi.get(self, "workspace")

    @workspace.setter
    def workspace(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "workspace", value)


class RepositoryGroupPermission(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 group_slug: Optional[pulumi.Input[str]] = None,
                 permission: Optional[pulumi.Input[str]] = None,
                 repo_slug: Optional[pulumi.Input[str]] = None,
                 workspace: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        """
        Provides a Bitbucket Repository Group Permission Resource.

        This allows you set explicit group permission for a repository.

        OAuth2 Scopes: `repository:admin`

        Note: can only be used when authenticating with Bitbucket Cloud using an _app password_. Authenticating via an OAuth flow gives a 403 error due to a [restriction in the Bitbucket Cloud API](https://developer.atlassian.com/cloud/bitbucket/rest/api-group-repositories/#api-repositories-workspace-repo-slug-permissions-config-groups-group-slug-put).

        ## Example Usage

        ```python
        import pulumi
        import pulumi_bitbucket as bitbucket

        example = bitbucket.RepositoryGroupPermission("example",
            workspace="example",
            repo_slug=bitbucket_repository["example"]["name"],
            group_slug=bitbucket_group["example"]["slug"],
            permission="read")
        ```

        ## Import

        Repository Group Permissions can be imported using their `workspace:repo-slug:group-slug` ID, e.g.

        ```sh
         $ pulumi import bitbucket:index/repositoryGroupPermission:RepositoryGroupPermission example workspace:repo-slug:group-slug
        ```

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] group_slug: Slug of the requested group.
        :param pulumi.Input[str] permission: Permissions can be one of `read`, `write`, and `admin`.
        :param pulumi.Input[str] repo_slug: The repository slug.
        :param pulumi.Input[str] workspace: The workspace id.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: RepositoryGroupPermissionArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Provides a Bitbucket Repository Group Permission Resource.

        This allows you set explicit group permission for a repository.

        OAuth2 Scopes: `repository:admin`

        Note: can only be used when authenticating with Bitbucket Cloud using an _app password_. Authenticating via an OAuth flow gives a 403 error due to a [restriction in the Bitbucket Cloud API](https://developer.atlassian.com/cloud/bitbucket/rest/api-group-repositories/#api-repositories-workspace-repo-slug-permissions-config-groups-group-slug-put).

        ## Example Usage

        ```python
        import pulumi
        import pulumi_bitbucket as bitbucket

        example = bitbucket.RepositoryGroupPermission("example",
            workspace="example",
            repo_slug=bitbucket_repository["example"]["name"],
            group_slug=bitbucket_group["example"]["slug"],
            permission="read")
        ```

        ## Import

        Repository Group Permissions can be imported using their `workspace:repo-slug:group-slug` ID, e.g.

        ```sh
         $ pulumi import bitbucket:index/repositoryGroupPermission:RepositoryGroupPermission example workspace:repo-slug:group-slug
        ```

        :param str resource_name: The name of the resource.
        :param RepositoryGroupPermissionArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(RepositoryGroupPermissionArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 group_slug: Optional[pulumi.Input[str]] = None,
                 permission: Optional[pulumi.Input[str]] = None,
                 repo_slug: Optional[pulumi.Input[str]] = None,
                 workspace: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = RepositoryGroupPermissionArgs.__new__(RepositoryGroupPermissionArgs)

            if group_slug is None and not opts.urn:
                raise TypeError("Missing required property 'group_slug'")
            __props__.__dict__["group_slug"] = group_slug
            if permission is None and not opts.urn:
                raise TypeError("Missing required property 'permission'")
            __props__.__dict__["permission"] = permission
            if repo_slug is None and not opts.urn:
                raise TypeError("Missing required property 'repo_slug'")
            __props__.__dict__["repo_slug"] = repo_slug
            if workspace is None and not opts.urn:
                raise TypeError("Missing required property 'workspace'")
            __props__.__dict__["workspace"] = workspace
        super(RepositoryGroupPermission, __self__).__init__(
            'bitbucket:index/repositoryGroupPermission:RepositoryGroupPermission',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            group_slug: Optional[pulumi.Input[str]] = None,
            permission: Optional[pulumi.Input[str]] = None,
            repo_slug: Optional[pulumi.Input[str]] = None,
            workspace: Optional[pulumi.Input[str]] = None) -> 'RepositoryGroupPermission':
        """
        Get an existing RepositoryGroupPermission resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] group_slug: Slug of the requested group.
        :param pulumi.Input[str] permission: Permissions can be one of `read`, `write`, and `admin`.
        :param pulumi.Input[str] repo_slug: The repository slug.
        :param pulumi.Input[str] workspace: The workspace id.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _RepositoryGroupPermissionState.__new__(_RepositoryGroupPermissionState)

        __props__.__dict__["group_slug"] = group_slug
        __props__.__dict__["permission"] = permission
        __props__.__dict__["repo_slug"] = repo_slug
        __props__.__dict__["workspace"] = workspace
        return RepositoryGroupPermission(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="groupSlug")
    def group_slug(self) -> pulumi.Output[str]:
        """
        Slug of the requested group.
        """
        return pulumi.get(self, "group_slug")

    @property
    @pulumi.getter
    def permission(self) -> pulumi.Output[str]:
        """
        Permissions can be one of `read`, `write`, and `admin`.
        """
        return pulumi.get(self, "permission")

    @property
    @pulumi.getter(name="repoSlug")
    def repo_slug(self) -> pulumi.Output[str]:
        """
        The repository slug.
        """
        return pulumi.get(self, "repo_slug")

    @property
    @pulumi.getter
    def workspace(self) -> pulumi.Output[str]:
        """
        The workspace id.
        """
        return pulumi.get(self, "workspace")

